ENT.Type         = "anim"
ENT.Base         = "base_gmodentity"
ENT.Spawnable            = false
ENT.AdminSpawnable        = false

if SERVER then

   AddCSLuaFile( "shared.lua" )

local RocketSpeed         = 4000 
local PingRadius         = 2800 
local PingRate             = 0.2
local WobbleScale         = 0.02
local TargetAffinity    = 0 
local GraceTime         = 1 
local Damage            = 300.20398620 

local sndThrustLoop = Sound("Missile.Accelerate")

local sndStop = Sound("ambient/_period.wav")


function ENT:PingTargets()

local curtarg = NULL
local curdist = PingRadius

    for _,ent in pairs(ents.FindInSphere(self.Position,PingRadius)) do
    
        if ent:IsValid() and 
        (ent:IsNPC() or ent:IsPlayer()) and
        ent ~= self.Entity and
        ent ~= self.Child then
            local entpos = ent:LocalToWorld(ent:OBBCenter())
            local dist = (entpos - self.Position):Length()
            if (dist < curdist or curtarg == self.Owner) and self:LOS(ent,entpos)  then
                curtarg = ent
                curdist = dist
            end
        end

    end

self.Target = curtarg

end


function ENT:LOS(ent,entpos)

    local trace = {}
    trace.start = self.Position
    trace.endpos = entpos
    local traceRes = util.TraceLine(trace)

return (traceRes.Entity == ent)

end

function ENT:Initialize()

    self.Entity:SetModel( "models/Weapons/W_missile.mdl" )
	
	self.Owner = self.Entity:GetOwner()
    self.Entity:PhysicsInit(SOLID_BBOX)
    self.Entity:SetMoveType(MOVETYPE_FLY)    
    self.Entity:SetSolid(SOLID_BBOX)
    self.Entity:SetCollisionGroup(COLLISION_GROUP_INTERACTIVE)

    self.Owner = self.Owner  or self.Entity
    self.Weapon = self.Weapon or self.Owner
    self.Target = NULL    
    self.Child = self.Child or NULL

    self.EmittingSound = false
    self.NextPing = CurTime() + GraceTime

    self.LastWobble = self.Entity:GetForward()
       
end

function ENT:VectorGet()
	local startpos = self.Entity:GetPos()
	
	local downtrace = {}
	downtrace.start = startpos
	downtrace.endpos = startpos + self.Entity:GetUp()*-5
	downtrace.filter = self.Entity
	tracedown = util.TraceLine(downtrace) 
	
	if (tracedown.Hit) then
		return (tracedown.HitNormal)
	else
		return(Vector(0,0,1))
	end
	
end

function ENT:Touch(hitEnt)

if hitEnt == self.Owner then return end --we need to do this so the player doesn't collide with his rockets when he fires them

local RocketAng = self.Entity:GetForward()

    if self.Child:IsValid() then
        self.Child:SetParent(nil)
        self.Child:SetPos(self.Position - RocketAng*72)
        if self.Child:IsPlayer() then
            self.Child:SetMoveType(MOVETYPE_WALK)
            self.Child:SetCollisionGroup(COLLISION_GROUP_PLAYER)
            self.Child:TakeDamage(200,self.Owner)
        else
            self.Child:Fire("kill","",0.2)
        end
    end
    
    if not self.Weapon:IsValid() then self.Weapon = self.Entity end --just in case
    
 	local effectdata = EffectData()
		effectdata:SetOrigin(self.Entity:GetPos())
	util.Effect("Explosion", effectdata)

	local effectdata = EffectData()
		effectdata:SetOrigin(self.Entity:GetPos())			// Where is hits
		effectdata:SetNormal(self:VectorGet())		// Direction of particles
		effectdata:SetEntity(self.Entity)		// Who done it?
		effectdata:SetScale(1.5)			// Size of explosion
		effectdata:SetRadius(40)		// What texture it hits
		effectdata:SetMagnitude(14)			// Length of explosion trails
		util.Effect( "autobazooka_explode_gdcw", effectdata )
    
    local explo = ents.Create( "env_explosion" )
        explo:SetOwner( self.Owner )
        explo:SetPos( self.Entity:GetPos() )
        explo:SetKeyValue( "iMagnitude", "800" )
        explo:SetKeyValue( "iRadiusOverride", "420" ) -- blaze it
        explo:Spawn()
        explo:Activate()
        explo:Fire( "Explode", "", 0 )
    
    
    local shake = ents.Create( "env_shake" )
        shake:SetOwner( self.Owner )
        shake:SetPos( self.Entity:GetPos() )
        shake:SetKeyValue( "amplitude", "1000" )
        shake:SetKeyValue( "radius", "2000" )  
        shake:SetKeyValue( "duration", "1.2" )  
        shake:SetKeyValue( "frequency", "400" )
        shake:SetKeyValue( "spawnflags", "4" )    
        shake:Spawn()
        shake:Activate()
        shake:Fire( "StartShake", "", 0 )
        
    for i=1,15 do
	
    local physExplo = ents.Create( "env_physexplosion" )
        physExplo:SetOwner( self.Owner )
        physExplo:SetPos( self.Entity:GetPos() )
        physExplo:SetKeyValue( "Magnitude", "100" ) 
        physExplo:SetKeyValue( "radius", "300" ) 
        physExplo:Spawn()
        physExplo:Fire( "Explode", "", 0.02 )
		
	end
        
    local ar2Explo = ents.Create( "env_ar2explosion" )
        ar2Explo:SetOwner( self.Owner )
        ar2Explo:SetPos( self.Entity:GetPos() )
        ar2Explo:Spawn()
        ar2Explo:Activate()
        ar2Explo:Fire( "Explode", "", 0 )
        
    
    for k, v in pairs ( ents.FindInSphere( self.Entity:GetPos(), 175 ) ) do	
	
		if math.Round(math.random( 0, 3 )) == 2 then
		
			if v:IsPlayer() or v:IsNPC() and v:IsValid() then
					
			v:SetMaterial("models/charple/charple3_sheet")
			v:Ignite((math.random(1,3)))
			
			end	
			
		end	
		
		if (GetConVar("ab_breakconstraints"):GetBool()) then
		
		constraint.RemoveAll(v)
		
		end
		
        v:Fire( "EnableMotion", "", math.random( 0, 0.5 ) )
		
    end

    self.Entity:EmitSound( "explode_4" )
    self:StopSounds()    
    self.Entity:Remove()

end


function ENT:OnTakeDamage(dmginfo)

    self.Entity:TakePhysicsDamage(dmginfo)
    
end


function ENT:Use( activator, caller )

end


function ENT:Think()

    if self.NextPing < CurTime() then
        self:PingTargets()
        self.NextPing = CurTime() + PingRate
    end

    self.Position = self.Entity:GetPos()
    
    
    --calculate wobblyness
    local Wobble = ((VectorRand()) + self.LastWobble):GetNormalized()
    local RocketAng = self.Entity:GetForward()
    local NewAng = Wobble*WobbleScale + RocketAng
    
    if self.Target:IsValid() then
        local Displacement = (self.Target:LocalToWorld(self.Target:OBBCenter()) - self.Position)
        NewAng = NewAng*(Displacement:Length()/PingRadius) + Displacement:GetNormalized()*TargetAffinity 
    end

    NewAng = NewAng:GetNormalized()

    self.Entity:SetAngles(NewAng:Angle())
    self.Entity:SetLocalVelocity(NewAng*RocketSpeed)

    self:StartSounds()    
    self.LastWobble = Wobble    

end
    



function ENT:OnRemove()
    self:StopSounds()
	self.Rocketing = false
end

function ENT:StartSounds()  
  
    if not self.EmittingSound then
        self.Entity:EmitSound(sndThrustLoop)
		
        self.EmittingSound = true
    end
	
end

function ENT:StopSounds()
    if self.EmittingSound then
        self.Entity:StopSound(sndThrustLoop)
        self.Entity:EmitSound(sndStop)
        self.EmittingSound = false
    end    
end

end

if CLIENT then

function ENT:Think()


	local effectdata = EffectData() 
    effectdata:SetOrigin( self.Entity:GetPos() )  
    effectdata:SetAngles( self.Entity:GetAngles() )  
    util.Effect( "autobazooka_trail", effectdata ) 

end
end